package com.biganto.visual.roompark.presentation.screen.web_cam

import android.os.Bundle
import android.view.View
import androidx.core.os.bundleOf
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.IBottomNavigation
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

const val SELECTED_CAM_INDEX_KEY = "SELECTED_CAM_INDEX"

class WebCamScreenController :
    BigantoBaseController<WebCamScreenViewState
            , WebCamScreen
            , WebCamScreenPresenter>
   , WebCamScreen {

    constructor(args: Bundle):super(args)

    constructor(id: Int) : super(bundleOf(SELECTED_CAM_INDEX_KEY to id))


    override fun onViewBound(v: View) {
        toolBar.hideAll()
        bottomNavigation.hide()
    }

    override fun injectDependencies() {
        getComponent()
    }

    @Inject
    override lateinit var injectedPresenter: WebCamScreenPresenter


//    @Inject
//    lateinit var snacky:ISnackBarProvider

    lateinit var rpActivity: RoomParkMainActivity

    fun getComponent() = DaggerWebCamScreenComponent
        .factory()
        .create(RoomParkApplication.component
            ,activity as RoomParkMainActivity
            ,args.getInt(SELECTED_CAM_INDEX_KEY))
        .inject(this)

//    @Inject
//    lateinit var ac: RoomParkMainActivity

    @Inject
    lateinit var bottomNavigation: IBottomNavigation

    override fun render(viewState: WebCamScreenViewState) {
        when(viewState){
            is WebCamScreenViewState.Idle -> render(viewState)
            is WebCamScreenViewState.CamSelected -> render(viewState)
            is WebCamScreenViewState.WebCamsLIstLoaded-> render(viewState)
            is WebCamScreenViewState.SomeError -> render(viewState)
        }
    }

    private fun render(viewState: WebCamScreenViewState.Idle){

    }

    private fun render(viewState: WebCamScreenViewState.SomeError) =
        showError(viewState.exception)

    private fun render(viewState: WebCamScreenViewState.CamSelected){

    }

    private fun render(viewState: WebCamScreenViewState.WebCamsLIstLoaded){

    }


    override fun getLayoutId(): Int = R.layout.webcam_screen


}